/*
 * Created on 27/08/2008
 */
package org.cyrano.editor.listeners;

import java.util.EventListener;

import javax.swing.event.EventListenerList;

/**
 * @author Demián Gutierrez
 */
public class CommandListenerProxy {

  protected EventListenerList eventListenerList;

  // --------------------------------------------------------------------------------

  public CommandListenerProxy(EventListenerList eventListenerList) {
    this.eventListenerList = eventListenerList;
  }

  // --------------------------------------------------------------------------------

  public void addCommandListener(CommandListener listener) {
    eventListenerList.add(CommandListener.class, listener);
  }

  public void delCommandListener(CommandListener listener) {
    eventListenerList.remove(CommandListener.class, listener);
  }

  // --------------------------------------------------------------------------------

  public EventListener[] getCommandListener() {
    return eventListenerList.getListeners(CommandListener.class);
  }

  // --------------------------------------------------------------------------------

  public void fireCommandEvent(CommandEvent evt) {
    EventListener[] eventListeners = getCommandListener();

    for (int i = 0; i < eventListeners.length; i++) {
      CommandListener listener = (CommandListener) eventListeners[i];
      listener.commandFired(evt);
    }
  }
}
