package org.cyrano.editor.parts;

import java.awt.Graphics2D;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

public abstract class BaseContainerViewPart extends BaseViewPart //
    implements
      ContainerViewPart {

  private List<ViewPart> viewPartList = new ArrayList<ViewPart>();

  // --------------------------------------------------------------------------------

  public BaseContainerViewPart(PartsRegister partsRegister) {
    super(partsRegister);
  }

  // --------------------------------------------------------------------------------

  @Override
  public void addChildren(ViewPart children) {
    viewPartList.add(children);
  }

  @Override
  public void delChildren(ViewPart children) {
    viewPartList.remove(children);
  }

  // --------------------------------------------------------------------------------

  public ViewPart getViewPartAt(Point point) {
    for (ViewPart viewPart : viewPartList) {
      ViewPart ret = viewPart.getViewPartAt(point);

      if (ret != null) {
        return ret;
      }
    }

    return super.getViewPartAt(point);
  }

  // --------------------------------------------------------------------------------

  @Override
  public void paint(Graphics2D g2d) {
    paintLeaf(g2d);

    for (ViewPart viewPart : viewPartList) {
      viewPart.paint(g2d);
    }
  }
}
