package org.cyrano.editor.tool;

import java.awt.Color;
import java.awt.Graphics2D;

public class RectangleAddFeedback implements EditPolicyFeedback {

  @Override
  public void paint(Graphics2D g2d, //
      EditPolicyMouseHandler editPolicyMouseHandler) {

    RectangleMouseHandler rmh = //
    (RectangleMouseHandler) editPolicyMouseHandler;

    if (rmh.getDraggedPt() == null) {
      return;
    }

    int x = rmh.getClickDwPt().x < rmh.getDraggedPt().x
        ? rmh.getClickDwPt().x
        : rmh.getDraggedPt().x;
    int y = rmh.getClickDwPt().y < rmh.getDraggedPt().y
        ? rmh.getClickDwPt().y
        : rmh.getDraggedPt().y;

    int w = Math.abs(rmh.getClickDwPt().x - rmh.getDraggedPt().x);
    int h = Math.abs(rmh.getClickDwPt().y - rmh.getDraggedPt().y);

    g2d.setColor(Color.LIGHT_GRAY);
    g2d.fillRect(x, y, w, h);

    g2d.setColor(Color.DARK_GRAY);
    g2d.fillRect(x, y, w, h);
  }
}
