package org.cyrano.timetable.ui.command;

import org.cyrano.editor.listeners.Command;
import org.cyrano.timetable.ui.model.base.Parent;

public class ReparentCommand<PARENT_TYPE, CHILDREN_TYPE> //
    implements
      Command {

  private Parent<PARENT_TYPE, CHILDREN_TYPE> oldPar;

  private Parent<PARENT_TYPE, CHILDREN_TYPE> newPar;

  private CHILDREN_TYPE/*                  */chl;

  // --------------------------------------------------------------------------------

  public ReparentCommand( //
      CHILDREN_TYPE chl, //
      Parent<PARENT_TYPE, CHILDREN_TYPE> oldPar, //
      Parent<PARENT_TYPE, CHILDREN_TYPE> newPar) {

    this.oldPar = oldPar;
    this.newPar = newPar;
    this.chl = chl;
  }

  // --------------------------------------------------------------------------------

  @Override
  public void redoCommand() {
    oldPar.del(chl);
    newPar.add(chl);
  }

  // --------------------------------------------------------------------------------

  @Override
  public void undoCommand() {
    newPar.del(chl);
    oldPar.add(chl);
  }

  // --------------------------------------------------------------------------------

  @Override
  public boolean canExecute() {
    return oldPar != newPar;
  }
}
