package org.cyrano.timetable.ui.main;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.apache.commons.io.IOUtils;
import org.cyrano.utils.ImageCache;

public class DlgAbout extends JDialog {

  public DlgAbout(JFrame parent) {
    setTitle(_I18NDlgAbout.title());
    setModal(true);
    setResizable(false);

    initGUI();

    pack();

    setLocationRelativeTo(parent);
  }

  // --------------------------------------------------------------------------------

  // TODO: use builder pattern
  protected GridBagConstraints initGBC( //
      int gx, int gy, int wx, int wy, int gw, int gh) {

    GridBagConstraints ret = new GridBagConstraints();

    ret.gridx/*     */= gx;
    ret.gridy/*     */= gy;
    ret.weightx/*   */= wx;
    ret.weighty/*   */= wy;
    ret.gridwidth/* */= gw;
    ret.gridheight/**/= gh;

    return ret;
  }

  // --------------------------------------------------------------------------------

  private void initGUI() {
    setLayout(new BorderLayout());
    add(initCenterPanel(), BorderLayout.CENTER);
    add(initButtonPanel(), BorderLayout.SOUTH);
  }

  // --------------------------------------------------------------------------------

  private JPanel initCenterPanel() {
    JPanel ret = new JPanel();

    ret.setBorder(BorderFactory.createCompoundBorder( //
        BorderFactory.createEmptyBorder(5, 5, 5, 5), //
        BorderFactory.createLineBorder(Color.BLACK, 1)));
    ret.setBackground(Color.WHITE);
    ret.setLayout(new GridBagLayout());

    GridBagConstraints gbc;

    JLabel lblCodeCompiling = new JLabel( //
        new ImageIcon(ImageCache.getInstance().getImage( //
            "images/code_compiling_logo.gif")));

    gbc = initGBC(0, 0, 1, 1, 0, 1);
    gbc.fill = GridBagConstraints.BOTH;
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.insets = new Insets(5, 5, 5, 5);
    ret.add(lblCodeCompiling, gbc);

    JEditorPane txtInfo = new JEditorPane();
    txtInfo.setMinimumSize(new Dimension(300, 300));
    txtInfo.setContentType("text/html");
    txtInfo.setText(loadAbout());
    txtInfo.setEditable(false);
    gbc = initGBC(0, 1, 1, 1, 1, 1);
    gbc.fill = GridBagConstraints.BOTH;
    gbc.anchor = GridBagConstraints.CENTER;
    gbc.insets = new Insets(5, 5, 5, 5);
    ret.add(txtInfo, gbc);

    return ret;
  }

  // --------------------------------------------------------------------------------

  private JPanel initButtonPanel() {
    JPanel ret = new JPanel(new FlowLayout());

    JButton btnClose = new JButton(_I18NDlgAbout.close());
    btnClose.setMinimumSize(new Dimension(80, 30));
    btnClose.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent evt) {
        DlgAbout.this.dispose();
      }
    });
    ret.add(btnClose);

    return ret;
  }

  // --------------------------------------------------------------------------------

  public String loadAbout() {
    try {
      return IOUtils.toString( //
          getClass().getResourceAsStream(_I18NDlgAbout.aboutHtml()));
    } catch (IOException e) {
      throw new RuntimeException();
    }
  }
}
