package org.cyrano.timetable.ui.model.base;

import java.util.Comparator;
import java.util.List;

public interface Parent<PARENT_TYPE, CHILDREN_TYPE> {

  public void add(CHILDREN_TYPE child, boolean fireEvent);

  public void add(CHILDREN_TYPE child);

  // --------------------------------------------------------------------------------

  public void del(CHILDREN_TYPE child, boolean fireEvent);

  public void del(CHILDREN_TYPE child);

  // --------------------------------------------------------------------------------

  public List<CHILDREN_TYPE> getChildrenList();

  // --------------------------------------------------------------------------------

  public int indexOf(CHILDREN_TYPE child);

  // --------------------------------------------------------------------------------

  public PARENT_TYPE getParentRef();

  // --------------------------------------------------------------------------------

  public void sort();

  // --------------------------------------------------------------------------------

  public void setSetter( //
      Setter<CHILDREN_TYPE, Children<PARENT_TYPE>> setter);

  // --------------------------------------------------------------------------------

  public void setStructureChangeSupport(
      StructureChangeSupport structureChangeSupport);

  // --------------------------------------------------------------------------------

  public void setComparator( //
      Comparator<CHILDREN_TYPE> comparator);

  // --------------------------------------------------------------------------------

  public <TARGET> List<CHILDREN_TYPE>/**/findMultChildBy(
      ObjectMatcher<CHILDREN_TYPE, TARGET> objectMatcher, TARGET target);

  public <TARGET> /*  */CHILDREN_TYPE/* */findSingChildBy(
      ObjectMatcher<CHILDREN_TYPE, TARGET> objectMatcher, TARGET target);

  // --------------------------------------------------------------------------------

  public void visitChildren(ObjectVisitor<CHILDREN_TYPE> objectVisitor);
}
