package org.cyrano.timetable.ui.model.base;

import java.util.EventObject;

public class StructureChangeEvent extends EventObject {

  private final Parent<?, ?> oldParent;

  private final Parent<?, ?> newParent;

  private final Object child;

  // --------------------------------------------------------------------------------

  public StructureChangeEvent(Object source, //
      Object child, Parent<?, ?> newParent, Parent<?, ?> oldParent) {

    super(source);

    this.child/* */= child;
    this.newParent = newParent;
    this.oldParent = oldParent;
  }

  // --------------------------------------------------------------------------------

  public Parent<?, ?> getOldParent() {
    return oldParent;
  }

  public Parent<?, ?> getNewParent() {
    return newParent;
  }

  // --------------------------------------------------------------------------------

  public Object getChild() {
    return child;
  }
}
