package org.cyrano.utils;

import java.text.MessageFormat;

public class Rect {

  public static final String STRING_FORMAT = //
  "x={0}, y={1}, w={2}, h={3}";

  // --------------------------------------------------------------------------------

  public int x;
  public int y;
  public int w;
  public int h;

  // --------------------------------------------------------------------------------

  public Rect() {
    // Empty
  }

  // --------------------------------------------------------------------------------

  public Rect(int x, int y, int w, int h) {
    set(x, y, w, h);
  }

  // --------------------------------------------------------------------------------

  public Rect(Rect rect) {
    this(rect.x, rect.y, rect.w, rect.h);
  }

  // --------------------------------------------------------------------------------

  public void set(int x, int y, int w, int h) {
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
  }

  // --------------------------------------------------------------------------------

  public int minX() {
    return x;
  }

  public int minY() {
    return y;
  }

  public int maxX() {
    return x + w;
  }

  public int maxY() {
    return y + h;
  }

  // --------------------------------------------------------------------------------

  public boolean contains(int x, int y) {
    return minX() <= x && x <= maxX() && minY() <= y && y <= maxY();
  }

  // --------------------------------------------------------------------------------

  @Override
  public String toString() {
    return MessageFormat.format( //
        STRING_FORMAT, x, y, w, h);
  }
}
